<a id="types-aiobotocore-amplifyuibuilder"></a>

# types-aiobotocore-amplifyuibuilder

[![PyPI - types-aiobotocore-amplifyuibuilder](https://img.shields.io/pypi/v/types-aiobotocore-amplifyuibuilder.svg?color=blue)](https://pypi.org/project/types-aiobotocore-amplifyuibuilder)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-amplifyuibuilder.svg?color=blue)](https://pypi.org/project/types-aiobotocore-amplifyuibuilder)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-amplifyuibuilder?color=blue)](https://pypistats.org/packages/types-aiobotocore-amplifyuibuilder)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[aiobotocore.AmplifyUIBuilder 2.3.4](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/amplifyuibuilder.html#AmplifyUIBuilder)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.10.0](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[types-aiobotocore](https://pypi.org/project/types-aiobotocore/) page and in
[types-aiobotocore-amplifyuibuilder docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_amplifyuibuilder/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [types-aiobotocore-amplifyuibuilder](#types-aiobotocore-amplifyuibuilder)
  - [How to install](#how-to-install)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)

<a id="how-to-install"></a>

## How to install

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `AmplifyUIBuilder` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[amplifyuibuilder]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[amplifyuibuilder]'


# standalone installation
python -m pip install types-aiobotocore-amplifyuibuilder
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y types-aiobotocore-amplifyuibuilder
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[amplifyuibuilder]` in your environment:

```bash
python -m pip install 'types-aiobotocore[amplifyuibuilder]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `types-aiobotocore-lite[amplifyuibuilder]` in your environment:

```bash
python -m pip install 'types-aiobotocore-lite[amplifyuibuilder]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `types-aiobotocore` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `types-aiobotocore` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[amplifyuibuilder]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed
  `types-aiobotocore`

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `types-aiobotocore[amplifyuibuilder]` with services you use in your
  environment:

```bash
python -m pip install 'types-aiobotocore[amplifyuibuilder]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[amplifyuibuilder]` in your environment:

```bash
python -m pip install 'types-aiobotocore[amplifyuibuilder]'`
```

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `types-aiobotocore[amplifyuibuilder]` in your environment:

```bash
python -m pip install 'types-aiobotocore[amplifyuibuilder]'
```

Optionally, you can install `types-aiobotocore` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`AmplifyUIBuilderClient` provides annotations for
`session.create_client("amplifyuibuilder")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_amplifyuibuilder import AmplifyUIBuilderClient

session = get_session()
async with session.create_client("amplifyuibuilder") as client:
    client: AmplifyUIBuilderClient
    # now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_amplifyuibuilder.paginator` module contains type annotations
for all paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_amplifyuibuilder import AmplifyUIBuilderClient
from types_aiobotocore_amplifyuibuilder.paginator import (
    ExportComponentsPaginator,
    ExportThemesPaginator,
    ListComponentsPaginator,
    ListThemesPaginator,
)

session = get_session()
async with session.create_client("amplifyuibuilder") as client:
    client: AmplifyUIBuilderClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        export_components_paginator: ExportComponentsPaginator = client.get_paginator("export_components")
        export_themes_paginator: ExportThemesPaginator = client.get_paginator("export_themes")
        list_components_paginator: ListComponentsPaginator = client.get_paginator("list_components")
        list_themes_paginator: ListThemesPaginator = client.get_paginator("list_themes")
    ```







### Literals

`types_aiobotocore_amplifyuibuilder.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_amplifyuibuilder.literals import (
    ExportComponentsPaginatorName,
    ExportThemesPaginatorName,
    ListComponentsPaginatorName,
    ListThemesPaginatorName,
    SortDirectionType,
    TokenProvidersType,
    AmplifyUIBuilderServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    RegionName,
)

def check_value(value: ExportComponentsPaginatorName) -> bool:
    ...
````

### Typed dictionaries

`types_aiobotocore_amplifyuibuilder.type_defs` module contains structures and
shapes assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_amplifyuibuilder.type_defs import (
    MutationActionSetStateParameterTypeDef,
    ComponentBindingPropertiesValuePropertiesTypeDef,
    ComponentConditionPropertyTypeDef,
    SortPropertyTypeDef,
    ComponentPropertyBindingPropertiesTypeDef,
    FormBindingElementTypeDef,
    ComponentSummaryTypeDef,
    ComponentVariantTypeDef,
    ResponseMetadataTypeDef,
    CreateThemeDataTypeDef,
    ThemeTypeDef,
    DeleteComponentRequestRequestTypeDef,
    DeleteThemeRequestRequestTypeDef,
    ExchangeCodeForTokenRequestBodyTypeDef,
    PaginatorConfigTypeDef,
    ExportComponentsRequestRequestTypeDef,
    ExportThemesRequestRequestTypeDef,
    GetComponentRequestRequestTypeDef,
    GetThemeRequestRequestTypeDef,
    ListComponentsRequestRequestTypeDef,
    ListThemesRequestRequestTypeDef,
    ThemeSummaryTypeDef,
    PredicateTypeDef,
    RefreshTokenRequestBodyTypeDef,
    ThemeValueTypeDef,
    ThemeValuesTypeDef,
    UpdateThemeDataTypeDef,
    ActionParametersTypeDef,
    ComponentBindingPropertiesValueTypeDef,
    ComponentDataConfigurationTypeDef,
    ComponentPropertyTypeDef,
    EmptyResponseMetadataTypeDef,
    ExchangeCodeForTokenResponseTypeDef,
    ListComponentsResponseTypeDef,
    RefreshTokenResponseTypeDef,
    CreateThemeRequestRequestTypeDef,
    CreateThemeResponseTypeDef,
    ExportThemesResponseTypeDef,
    GetThemeResponseTypeDef,
    UpdateThemeResponseTypeDef,
    ExchangeCodeForTokenRequestRequestTypeDef,
    ExportComponentsRequestExportComponentsPaginateTypeDef,
    ExportThemesRequestExportThemesPaginateTypeDef,
    ListComponentsRequestListComponentsPaginateTypeDef,
    ListThemesRequestListThemesPaginateTypeDef,
    ListThemesResponseTypeDef,
    RefreshTokenRequestRequestTypeDef,
    UpdateThemeRequestRequestTypeDef,
    ComponentEventTypeDef,
    ComponentChildTypeDef,
    ComponentTypeDef,
    CreateComponentDataTypeDef,
    UpdateComponentDataTypeDef,
    CreateComponentResponseTypeDef,
    ExportComponentsResponseTypeDef,
    GetComponentResponseTypeDef,
    UpdateComponentResponseTypeDef,
    CreateComponentRequestRequestTypeDef,
    UpdateComponentRequestRequestTypeDef,
)

def get_structure() -> MutationActionSetStateParameterTypeDef:
    return {
      ...
    }
```

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for
`aiobotocore` updates. It delivers a drop-in type annotations for you and makes
sure that:

- All available `aiobotocore` services are covered.
- Each public class and method of every `aiobotocore` service gets valid type
  annotations extracted from the documentation (blame `botocore` docs if types
  are incorrect).
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

## What's new

### Implemented features

- Fully type annotated `boto3`, `botocore` and `aiobotocore` libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.session` calls
- Auto discovery of types for `session.client` and `session.session` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

## Versioning

`types-aiobotocore-amplifyuibuilder` version is the same as related
`aiobotocore` version and follows
[PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

## Documentation

All services type annotations can be found in
[aiobotocore docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_amplifyuibuilder/)

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
